Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.4.1 generated on May 30 2006
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## kodo.datacache
Interface QueryCache

All Superinterfaces:
  com.solarmetric.util.Closeable

All Known Implementing Classes:
  AbstractQueryCache

public interface QueryCache
extends com.solarmetric.util.Closeable

Interface that must be implemented by any level 2 query cache used by Kodo. These methods should be synchronized. Most query cache implementations will probably implement `Configurable` to receive a handle to the system configuration on construction.

Since:
  2.5

Method Summary
`void` | `addExpirationListener(ExpirationListener listen)` Add a new expiration event listener to this cache.
`void` | `classesChanged(Collection classes)` Tells the cache that all the classes in the `classes` set have been changed.
`void` | `clear()` Remove all data from this cache.
`void` | `close()` Free the resources used by this cache.
`QueryResult` | `get(QueryKey qk)` Return a list of oids for the given query key.
`boolean` | `pin(QueryKey qk)` Pin the value stored under `qk` into the cache.
`QueryResult` | `put(QueryKey qk, QueryResult oids)` Set the list of OIDs for the given query key.
`QueryResult` | `remove(QueryKey qk)` Remove the value stored under the given query key.
`boolean` | `removeExpirationListener(ExpirationListener listen)` Remove an expiration event listener from this cache.
`boolean` | `unpin(QueryKey qk)` Unpin the value stored under `key` into the cache.

Method Detail

### classesChanged

    public void classesChanged(Collection classes)

  Tells the cache that all the classes in the `classes` set have been changed. This could mean that items have been updated, deleted, or added. This limits the `QueryCache` to only be able to invalidate cached queries -- because the cache is not notified of actual changes, it cannot recompute query results.

  After this method is invoked, all cached results that correspond to queries that use one of the classes in `classes` will be dropped.

  Parameters:
    `classes` - a set of `Class` objects that correspond to instances that have changed

### get

    public QueryResult get(QueryKey qk)

  Return a list of oids for the given query key. This is an unmodifiable list.

  Returns:
    The query results matching the given key, or null if none

### put

    public QueryResult put(QueryKey qk,
                           QueryResult oids)

  Set the list of OIDs for the given query key. A reference to the given list will be stored in the query cache, so the list should not be modified after invoking this method.

  Returns:
    The previously cached value, or `null` if the key was not previously cached. See `Map.put(java.lang.Object, java.lang.Object)` for more information.

### remove

    public QueryResult remove(QueryKey qk)

  Remove the value stored under the given query key.

  This method is typically not invoked directly from outside the `QueryCache` class. Instead, the cache should be updated by invoking `#notifyChangedClasses`, which will result in all queries that may be invalid being dropped.

  Returns:
    The previously cached value, or `null` if the key was not previously cached. See `Map.remove(java.lang.Object)` for more information.

### clear

    public void clear()

  Remove all data from this cache.

### pin

    public boolean pin(QueryKey qk)

  Pin the value stored under `qk` into the cache. This method guarantees that `qk`'s value will not be expired if the cache exceeds its capacity. It causes this data to be ignored when determining whether or not the cache is full, effectively increasing the total amount of data stored in the cache. This method does not affect the behavior of `remove(kodo.datacache.QueryKey)` or `#notifyChangedClasses`.
  Returns:
    `true` if `key`'s value was pinned into the cache; `false` if the key is not in the cache.

### unpin

    public boolean unpin(QueryKey qk)

  Unpin the value stored under `key` into the cache. This method reverses a previous invocation of `pin(kodo.datacache.QueryKey)`. This method does not remove anything from the cache; it merely makes `key`'s value a candidate for flushing from the cache.
  Returns:
    `true` if `key`'s value was unpinned from the cache; `false` if the key is not in the cache.

### addExpirationListener

    public void addExpirationListener(ExpirationListener listen)

  Add a new expiration event listener to this cache.
  Since:
    3.3

### removeExpirationListener

    public boolean removeExpirationListener(ExpirationListener listen)

  Remove an expiration event listener from this cache.
  Since:
    3.3

### close

    public void close()

  Free the resources used by this cache.
  Specified by:
    `close` in interface `com.solarmetric.util.Closeable`

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.4.1 generated on May 30 2006
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002 SolarMetric, Inc. All Rights Reserved.